﻿
// CSMQTTDlg.cpp: 实现文件
//

#include "pch.h"
#include "framework.h"
#include "CSMQTT.h"
#include "CSMQTTDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCSMQTTDlg 对话框



CCSMQTTDlg::CCSMQTTDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_CSMQTT_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCSMQTTDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CCSMQTTDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CCSMQTTDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CCSMQTTDlg 消息处理程序

BOOL CCSMQTTDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码

	server.SetFunc([this](SOCKET sock, int index, char* buf, short len) {CCSMQTTDlg::Process(sock, index, buf, len); });
	server.CreatServer(1995);
	

	//clien[1].Create();
	//clien[1].Connect(_T("127.0.0.1"), 1883);
	//clien[1].SetConnectFun([this](int i) {CCSMQTTDlg::Process(i); });
	//clien[1].SetFunc([this](int i) {CCSMQTTDlg::Proc(1); }, 1);
	
	file.Open(_T("D://1.txt"), CFile::modeCreate | CFile::modeReadWrite);

	file1.Open(_T("D://2.txt"), CFile::modeCreate | CFile::modeReadWrite);
	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CCSMQTTDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CCSMQTTDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CCSMQTTDlg::OnBnClickedOk()
{
	// TODO: 在此添加控件通知处理程序代码
	CDialogEx::OnOK();
}

VOID CCSMQTTDlg::Process(SOCKET sock, int index, char* buf, short len)
{
	if(clien.find(index)== clien.end())
	{
		clien[index].Create();
		clien[index].Connect(_T("127.0.0.1"), 1883);
		clien[index].SetConnectFun([this](int i) {CCSMQTTDlg::Process(i); });
		clien[index].SetFunc([this] (){CCSMQTTDlg::Proc(); });
	}
	Sleep(100);
	CStringA str;
	str.Format("\r\n收到一条消息%d\r\n", index);
	int l = clien[index].Send(buf, len, 0);
	file.Write(str, str.GetLength());
	file.Write(buf, len);
	//CStringA str = buf;
}

VOID CCSMQTTDlg::Proc(int id)
{
	CStringA str;
	str.Format("\r\n收到一条消息%d\r\n", id);
	file1.Write(str, str.GetLength());
	char* buf;
	int len;
	clien[id].GetMsg(&buf,len);
	len = server.SendTo(id, buf, len);
	file1.Write(buf, len);
	delete[]buf;
}

VOID CCSMQTTDlg::Process(int type)
{
	int i = type;
}
